// OC4502 WORKSHOP solution
// class List_LIFO

extern ofstream file;

template <class DataType>
class List_LIFO :  public LIFO <DataType>
{
private: // state
   List_Structure <DataType> myimpl;
public:
	// constructor
	List_LIFO () :  myimpl (){ mystruct = &myimpl;}
	// copy constructor
	List_LIFO (const List_LIFO& source) :	myimpl (source.myimpl) 
    { mystruct = &myimpl;}

	// no need for a destructor: it will indirectly call by default the
	// destructor of List_Structure

	// = operator assigns one set to another re-allocating array 
	// if necessary
	List_LIFO & operator= (const List_LIFO& source)
	{
		myimpl = source.myimpl;
		mystruct = &myimpl;
		return *this;
	}
};

