// OC4502 WORKSHOP solution
// class Array_FIFO

template <class DataType>
class Array_FIFO :  public FIFO <DataType>
{
private: // State
   Array_Structure <DataType> myimpl;

public:
	// constructor
	Array_FIFO (int size) :  myimpl (size) { mystruct = &myimpl;}
	// copy constructor
	Array_FIFO (const Array_FIFO& source) 
	: myimpl (source.myimpl) { mystruct = &myimpl;}

	// no need for a destructor: it will indirectly call by default the
	// destructor of Array_Structure

	// = operator assigns one set to another re-allocating array 
	// if necessary
	Array_FIFO &operator= (const Array_FIFO& source)
	{
		myimpl = source.myimpl;
		mystruct = &myimpl;
		return *this;
	}
};

