// OC4502 WORKSHOP solution
// clss Array_LIFO

template <class DataType>
class Array_LIFO :  public LIFO <DataType>
{
private: // State
   Array_Structure <DataType> myimpl;
public:
	// constructor
	Array_LIFO (int size) :  myimpl (size) { mystruct = &myimpl;}
	// copy constructor
	Array_LIFO (const Array_LIFO& source) 
	: myimpl (source.myimpl) { mystruct = &myimpl;}

	// no need for a destructor: it will indirectly call by default the
	// destructor of Array_Structure

	// = operator assigns one set to another re-allocating array 
	// if necessary
	Array_LIFO& operator= (const Array_LIFO& source)
	{
		myimpl = source.myimpl;
		mystruct = &myimpl;
		return *this;
	}
};

