// OC4502 WORKSHOP solution
// class List_FIFO

extern ofstream file;

template <class DataType>
class List_FIFO : public FIFO  <DataType>
{
private: // State
   List_Structure <DataType> myimpl;
public:
	// constructor
	List_FIFO () : myimpl () { mystruct = &myimpl;}
	// copy constructor
	List_FIFO (const List_FIFO& source) 
	: myimpl (source.myimpl) { mystruct = &myimpl;}

	// no need for a destructor: it will indirectly call by default the
	// destructor of List_Structure

	// = operator assigns one set to another re-allocating array 
	// if necessary
	List_FIFO & operator= (const List_FIFO& source)
	{
		myimpl = source.myimpl;
		mystruct = &myimpl;
		return *this;
	}
};

